<?php

/**
 *      (C)2007-2012 singcere.net
 *      This is a freeware, But you have no right to modify or distribute
 *
 *      $Id: function_singcere_core.php 11 2012-12-14 14:36:20Z except10n $
 */

if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}


function s_lang($key, $var = array(), $output = FALSE) {
	$output && print(lang('plugin/'.S_PLUGINNAME, $key, $var));
	return lang('plugin/'.S_PLUGINNAME, $key, $var);
}


function s_libfile($libname, $plugin = S_PLUGINNAME) {
	$pluginpath = DISCUZ_ROOT.'/source/plugin/'.$plugin;
	return realpath("$pluginpath/{$libname}.php");
}

function s_empty() {
	$numargs = func_num_args();
	$arglist = func_get_args();
	for($i = 0; $i < $numargs; $i++) {
		if(empty($arglist[$i])) {
			return true;
		}
	}
	return false;
}


/**
 * 
 * @param string $needle 被判断的字符串
 * @param string[] $haystack 字符串数组, 当参数为二维数组时,必须指定$keyname作为数组判断依据
 * @param string $keyname 二维数组每行需要进行比较的键名
 * @param string $expl 对$keyname指定的值,进行分割的元素值,为空时对整个字符串进行比较
 * @return 未找到返回FALSE, 否则返回$needle所在数组的键值
 */
function s_in_array($needle, $haystack, $keyname, $expl = '') {
	if(empty($keyname)) {
		return in_array($needle, $haystack);
	} else {
		if(empty($expl)) {
			foreach($haystack as $key => $item) {
				if($needle == $item[$keyname]) {
					return $key;
				}
			}
		} else {
			foreach($haystack as $key => $item) {
				$subarr = explode($expl, $item[$keyname]);
				if(in_array($needle, $subarr)) {
					return $key;
				}
			}
		}
		return FALSE;
	}
}

function getpluginparam($param, $plugin = S_PLUGINNAME) {
	global $_G;
	if(!isset($_G['cache']['plugin'][$plugin])) {
		loadcache('plugin');
	}
	return $_G['cache']['plugin'][$plugin][$param];
}

function recordsort($recordarray, $skey, $type = 0) {
	$newrecordarray = $keyarray = array();
	foreach($recordarray as $key=>$record) {
		$keyarray[$key] = $record[$skey];
	}
	
	$type == 0 ? asort($keyarray) : arsort($keyarray);
	reset($keyarray);
	foreach($keyarray as $key=>$value) {
		$newrecordarray[$key] = $recordarray[$key];
	}
	return $newrecordarray;
}

function array_iconv($in_charset,$out_charset, $arr) {
	return eval('return '.iconv($in_charset,$out_charset,var_export($arr,true).';'));
}

function insertadmincpstyle() {
	echo "<style>
			.s-td-50{width: 50px;}
			.s-td-75{width: 75px;}
			.s-td-100{width: 100px;}
			.s-td-150{width: 150px;}
			.s-td-200{width: 200px;}
		</style>";
}